// 002 u_cgi_environment
// 04 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_cgi_environment;
  interface

    function f_write_environment_key_value(p_key, p_value: String): Boolean;
    function f_get_environment_value(p_key: pChar): String;
    function f_get_all_environment_string: String;

  implementation
    uses Windows, SysUtils;

    function f_write_environment_key_value(p_key, p_value: String): Boolean;
      begin
        if (p_key<> '') and (p_value<> '')
          then Result:= SetEnvironmentVariable(pChar(p_key), pChar(p_value));
      end; // write_environment_key_value

    function f_get_environment_value(p_key: pChar): String;
      const k_max= 255;
      var l_environment_value: String[k_max];
          l_size: Integer;
      begin
        l_size:= GetEnvironmentVariable(p_key, @ l_environment_value[1], k_max);
        l_environment_value[0]:= chr(l_size);
        Result:= l_environment_value;
      end; // f_get_environment_value

    function f_get_all_environment_string: String;
        // -- get all the environment variables
      var l_pchar: PChar;
          l_running_pchar: pChar;
          l_environment_line: ShortString;
      begin
        l_pchar:= GetEnvironmentStrings;

        Result:= '';
        l_running_pchar:= l_pchar;

        while l_running_pchar^<> #0 do
        begin
          l_environment_line:= StrPas(l_running_pchar);
          Result:= Result+ l_environment_line+ chr(13)+chr(10);
          Inc(l_running_pchar, StrLen(l_running_pchar)+ 1)
        end; // while

        FreeEnvironmentStrings(l_pchar);
      end; // f_get_all_environment_string

    begin // u_c_yyy
    end. // u_c_yyy
