// 003 u_cgi_training_handler
// 19 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_cgi_training_handler;
  Interface

    procedure do_handle_cgi(p_write_segment,
        p_log_name, p_site_url: String);

    const // -- default to get string to system
          k_output= '';
    var // -- will be filled by the caller in debug mode
        g_output_name: String= k_output;
        g_debug_request: String= '';

  Implementation
    uses Classes, SysUtils
        , u_c_cgi_log, u_cgi_helpers, u_cgi_environment
        , u_c_cgi_basic_object

        , u_c_cgi_base_forms

        , u_c_cgi_html_base_page_builder
        ;

    const k_content_type= 'Content-type: text/html';

    procedure do_handle_cgi(p_write_segment,
        p_log_name, p_site_url: String);

      function f_is_debug: Boolean;
        begin
          Result:= g_output_name<> k_output;
        end; // f_is_debug

      procedure log_enviroment;
        begin
          write_log('|'+ f_get_all_environment_string+ '|');
        end; // log_environment

      procedure analyze_form_values(var pv_c_key_value_list: tStringList);
        var l_raw_request_string: String;
        begin
          if f_is_debug
            then extract_key_values(g_debug_request, pv_c_key_value_list)
            else
              with c_base_form.create_base_form('forms') do
              begin
                get_form_result;

                if f_is_debug
                  then l_raw_request_string:= g_debug_request
                  else l_raw_request_string:= m_raw_answer_string;

                pv_c_key_value_list:= tStringList.Create;
                extract_key_values(l_raw_request_string, pv_c_key_value_list);

                write_log('Received:');
                write_log('  Rem >'+ m_remote_address_string+ '<');
                write_log('  raw >'+ l_raw_request_string+ '<');

                Free;
              end; // with c_form.create_form
        end; // analyze_form_values

      procedure evaluate_request(p_c_key_value_list: tStringList;
          p_c_cgi_html_training_page_builder: c_html_base_page_builder);
        var l_result, l_e_mail: String;
        begin
          l_result:= '';
          with p_c_key_value_list do
          begin
            if values['database']= 'on'
              then l_result:= l_result+ 'db, ';
            if values['oo']= 'on'
              then l_result:= l_result+ 'object oriented, ';
            if values['uml_dp']= 'on'
              then l_result:= l_result+ 'uml, ';

            if l_result<> ''
              then System.Delete(l_result, Length(l_result)- 1, 2);
            l_e_mail:= values['e_mail'];
          end; // with p_c_key_value_list

          write_log(' kv ='+ p_c_key_value_list.Text+ '|+');

          write_log(' resu ='+ l_result);

          with p_c_cgi_html_training_page_builder do
          begin
            build_page_start;
            if l_result= ''
              then build_line('Thank you for visiting our site.')
              else begin
                  build_line('Thank your for contacting us about our ');
                  build_line(l_result);
                  build_line('trainings.<BR>');
                end;
            if l_e_mail<> ''
              then build_line('The information will bet send at '+ l_e_mail);
            build_page_end;
          end;
        end; // evaluate_request

      procedure send_answer(p_output_name: String;
          p_c_cgi_html_training_page_builder: c_html_base_page_builder);
        var l_output: Text;

        procedure send_empty_answer;
          begin
            writeln(l_output, '<HTML>');
            writeln(l_output, '  <BODY>');
            writeln(l_output, '    No answer');
            writeln(l_output, '  </BODY>');
            writeln(l_output, '</HTML>');
          end; // send_empty_answer

        var l_length: Integer;
            l_line_index: Integer;

        begin // send_answer
          // -- now output the answer
          Assign(l_output, p_output_name);
          Rewrite(l_output);

          write_log('  => Answser: header_ok');

          with p_c_cgi_html_training_page_builder.m_c_html_page do
          begin
            l_length:= Length(Text);

            // writeln(l_output, 'HTTP/1.0 200 OK');
            // -- for the .HTML debug output, do not send the header
            if not f_is_debug or (ExtractFileExt(p_output_name)<> '.html')
              then begin
                  writeln(l_output, k_content_type);
                  if l_length<> 0
                    then writeln(l_output, 'Content-Length='+ IntToStr(Length(Text)));
                  writeln(l_output);
                end;

            if Count= 0
              then send_empty_answer
              else begin
                  for l_line_index:= 0 to Count- 1 do
                    write_log('  |'+  Strings[l_line_index]+ '|');

                  write(l_output, Text);
                end;
          end; // with p_c_cgi_html_training_page_builder

          Close(l_output);

          write_log('  ok_sent');
        end; // send_answer

      procedure test_answer_ok;
          // -- bogus trial
        var l_output: Text;
        begin
          // -- now build the answer
          Assign(l_output, g_output_name);
          Rewrite(l_output);

          // writeln(l_output, 'HTTP/1.0 200 OK');
          writeln(l_output, k_content_type);
          writeln(l_output);

          writeln(l_output, '<HTML>');
          writeln(l_output, '  <BODY>');
          writeln(l_output, '    log_ok ok');
          writeln(l_output, '  </BODY>');
          writeln(l_output, '</HTML>');

          Close(l_output);
        end; // test_answer_ok

      var l_c_key_value_list: tStringList;
          l_site_url: String;
          l_c_cgi_html_training_page_builder: c_html_base_page_builder;

      begin // do_handle_cgi
        open_log(f_cgi_exe_path+ p_write_segment+ p_log_name);
        // -- debug
        // log_enviroment;

        // -- get the request without % etc
        write_log('== analyze_form_values');
        l_c_key_value_list:= tStringList.Create;

        analyze_form_values(l_c_key_value_list);

        write_log('== load_cgi_text');

        if f_is_debug
          then l_site_url:= ''
          else l_site_url:= p_site_url;

        l_c_cgi_html_training_page_builder:=
            c_html_base_page_builder.create_html_base_page_builder('request',
            l_site_url);

        // -- build the target file list
        evaluate_request(l_c_key_value_list, l_c_cgi_html_training_page_builder);

        write_log('== send_answer');
        // test_answer_ok
        send_answer(g_output_name, l_c_cgi_html_training_page_builder);
        // -- in debug mode, also output an .html version of the answer on the local disc
        if f_is_debug
          then send_answer(ChangeFileExt(g_output_name, '.html'), l_c_cgi_html_training_page_builder);

        l_c_key_value_list.Free;
        l_c_cgi_html_training_page_builder.Free;

        write_log('== end ok');
      end; // do_handle_cgi

    end.